<script lang="ts">
  interface Option {
    value: string;
    label: string;
    isHidden?: boolean;
  }

  // Define props
  export let id: string | undefined = undefined;
  export let value: string;
  export let options: Option[];
  export let extraClasses: string = '';

  let isOpen = false;

  function openMenu() {
    isOpen = true;
    document.body.addEventListener('click', closeMenu);
  }

  function closeMenu() {
    isOpen = false;
    document.body.removeEventListener('click', closeMenu);
  }
</script>

<div class="relative inline-block">
  <button
    on:click|stopPropagation={() => {
      isOpen ? closeMenu() : openMenu();
    }}
    {id}
    class="inline-flex cursor-pointer items-center rounded border border-gray-300 bg-gray-100 px-3 py-2 hover:border-gray-400 hover:bg-gray-200 {extraClasses}"
    type="button"
  >
    {options.find((el) => el.value === value)?.label}
    <svg class="ml-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
      ><path
        fill="none"
        stroke="currentColor"
        stroke-linecap="round"
        stroke-linejoin="round"
        stroke-width="2"
        d="m6 9l6 6l6-6"
      /></svg
    >
  </button>

  {#if isOpen}
    <div
      class="absolute left-0 top-10 z-20 min-w-full rounded-md border border-gray-200 bg-white overflow-auto max-h-80"
    >
      {#each options.filter((el) => !el.isHidden) as option}
        <button
          on:click|stopPropagation={() => {
            value = option.value;
            closeMenu();
          }}
          type="button"
          class="block w-full px-3 py-2 text-left hover:bg-gray-100">{option.label}</button
        >
      {/each}
    </div>
  {/if}
</div>
